package com.kcim.dao.repository;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.kcim.common.util.UserContext;
import com.kcim.dao.mapper.ItemEmpMapMapper;
import com.kcim.dao.model.ItemEmpMap;
import com.kcim.dao.model.StandItemEmpMap;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;
import java.util.Objects;

/**
 * @program: CostAccount
 * @description: 医疗服务项目参与人员对照数据库交互
 * @author: Wang.YS
 * @create: 2024-01-11 17:12
 **/
@Repository
public class ItemEmpMapRepository extends ServiceImpl<ItemEmpMapMapper, ItemEmpMap> {
    public void removeByItemCode(List<String> collect) {
        LambdaUpdateWrapper<ItemEmpMap> updateWrapper = new LambdaUpdateWrapper<>();
        updateWrapper.eq(ItemEmpMap::getDelFlag,0)
                .eq(ItemEmpMap::getHospId, UserContext.getHospId())
                .in(ItemEmpMap::getItemCode,collect)
                .set(ItemEmpMap::getDelFlag,1)
                .set(ItemEmpMap::getDeleteUser,String.valueOf(UserContext.getCurrentUser().getId()))
                .set(ItemEmpMap::getDeleteTime,new Date());
        this.update(updateWrapper);

    }

    public List<ItemEmpMap> getList() {
        LambdaQueryWrapper<ItemEmpMap> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(ItemEmpMap::getHospId, UserContext.getHospId());
        return this.list(queryWrapper);

    }

    public List<ItemEmpMap> getList(String itemCode) {
        LambdaQueryWrapper<ItemEmpMap> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(ItemEmpMap::getHospId, UserContext.getHospId());
        queryWrapper.eq(ItemEmpMap::getItemCode, itemCode);
        return this.list(queryWrapper);
    }

    public void deleteItemEmpMap(Integer id) {
        ItemEmpMap itemEmpMap = this.getById(id);
        if(Objects.nonNull(itemEmpMap)){
            itemEmpMap.setDeleteUser(String.valueOf(UserContext.getCurrentUser().getId()));
            itemEmpMap.setDeleteTime(new Date());
            this.updateById(itemEmpMap);
            this.removeById(id);
        }
    }

    public List<ItemEmpMap> getList(String itemCode, String departmentCode) {
        LambdaQueryWrapper<ItemEmpMap> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(ItemEmpMap::getHospId, UserContext.getHospId());
        queryWrapper.eq(ItemEmpMap::getItemCode, itemCode);
        queryWrapper.eq(ItemEmpMap::getDepartmentCode, departmentCode);

        return this.list(queryWrapper);
    }
}
